function TrueModel=setup_params(COND,TrueModel)
%% function TrueModel=setup_params(COND,TrueModel)
% Defines a number of synthetic datasets.
% COND: Specifies the dataset to create

    if(COND==5)
        of = 0.01; 
        on = 0.49;
        % IN on cols. OUT on rows.
    %     TrueModel.theta = [[on,of,on,of];
    %                        [on,of,of,on];
    %                        [of,on,of,on];
    %                        [of,on,on,of]];

        TrueModel.theta = [[on,on,on,of,of];
                           [on,of,of,on,on];
                           [of,on,of,of,on];
                           [of,of,on,on,of]];

        [Ny,Nz]=size(TrueModel.theta);

        w_t = zeros(5,5,4);
        w_t(:,:,1) = [[0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, .25, 0, 0];
                      [0, 0, 0, 0, 0];                  
                      [0, 0, 0, 0, 0]];
        w_t(:,:,2) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .25, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0]];              
        w_t(:,:,3) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [1, 1, .25, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];  
        w_t(:,:,4) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .25, 1, 1];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];                
        w_t = w_t+0.01; Nx = 25;
        phi = zeros(Nx, Ny);
        for y = 1 : 4, phi(:,y) = normalise(reshape(w_t(:,:,y), [Nx, 1])); end
        TrueModel.Nd = 10;
        TrueModel.phi = intersectionPhi;

        TrueModel.psi0 = ones(Nz,1)/Nz;
        %TrueModel.psi  = [[0.75, 0.25]; [0.25, 0.75]];
    %     psi           = [[2, 0, 0, 1];
    %                      [1, 2, 0, 0];
    %                      [0, 1, 2, 0];
    %                      [0, 0, 1, 2]] + 0.05;
        psi           = [[2, 0, 0, 0, 1];
                         [1, 2, 0, 0, 0];
                         [0, 1, 2, 0, 0];
                         [0, 0, 1, 2, 0];
                         [0, 0, 0, 1, 2]] + 0.05;

        TrueModel.psi = normalise(psi, 2);
    end
    if(COND==-8) %%Allows different ordering than #4
        %Allows straight, top left turn & bottom right turn.
        TrueModel.theta = [[0.49,0.49,0.01,0.01];
                           [0.49,0.01,0.01,0.49];
                           [0.01,0.49,0.49,0.01];
                           [0.01,0.01,0.49,0.49]];
        [Ny,Nz]=size(TrueModel.theta);

        TrueModel.Nd = 10;
        %TrueModel.phi = phi; 
        TrueModel.phi = intersectionPhi;

        TrueModel.psi0 = ones(Nz,1)/Nz;
        %TrueModel.psi  = [[0.75, 0.25]; [0.25, 0.75]];
        psi           = [[2, 1, 0, 0];
                         [0, 2, 1, 0];
                         [0, 0, 2, 1];
                         [1, 0, 0, 2]];
        TrueModel.psi  = normalise(psi+0.02,2);
    end
    if(COND==-4) %%Allows different clusters than #4
        %Allows straight, top left turn & bottom right turn.
        TrueModel.theta = [[0.49,0.01,0.01,0.49];
                           [0.49,0.01,0.49,0.01];
                           [0.01,0.49,0.49,0.01];
                           [0.01,0.49,0.01,0.49]];
        [Ny,Nz]=size(TrueModel.theta);

        TrueModel.Nd = 10;
        %TrueModel.phi = phi; 
        TrueModel.phi = intersectionPhi;

        TrueModel.psi0 = ones(Nz,1)/Nz;
        %TrueModel.psi  = [[0.75, 0.25]; [0.25, 0.75]];
        psi           = [[2, 0, 0, 1];
                         [1, 2, 0, 0];
                         [0, 1, 2, 0];
                         [0, 0, 1, 2]];
        TrueModel.psi  = normalise(psi+0.02,2);
    end
    if(COND==44)
        %Allows straight, top left turn & bottom right turn.
        % Some random order.
        p = 0.49;
        n = 0.01;
        TrueModel.theta = [[n, n, p, p];
                           [p, n, p, n];
                           [p, n, n, p];
                           [n, p, n, p];
                           [p, p, n, n]]';

        [Ny,Nz]=size(TrueModel.theta);

        w_t = zeros(5,5,4);
        w_t(:,:,1) = [[0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, .5, 0, 0];
                      [0, 0, 0, 0, 0];                  
                      [0, 0, 0, 0, 0]];
        w_t(:,:,2) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .5, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0]];              
        w_t(:,:,3) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [1, 1, .5, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];  
        w_t(:,:,4) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .5, 1, 1];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];                
        w_t = w_t+0.02; Nx = 25;
        phi = zeros(Nx, Ny);
        for y = 1 : 4, phi(:,y) = normalise(reshape(w_t(:,:,y), [Nx, 1])); end
        TrueModel.Nd = 10;
        TrueModel.phi = phi;

        TrueModel.psi0 = ones(Nz,1)/Nz;
        %TrueModel.psi  = [[0.75, 0.25]; [0.25, 0.75]];
        psi           = [[2, 0, 0, 0, 1];
                         [1, 2, 0, 0, 0];
                         [0, 1, 2, 0, 0];
                         [0, 0, 1, 2, 0];
                         [0, 0, 0, 1, 2]];
        TrueModel.psi  = normalise(psi+0.02,2);
    end
    if(COND==6)
        p = 0.33;
        n = 0.01;
        % Only allow curves to follow straights.
        TrueModel.theta = [[p,p,p,n];
                           [p,n,p,p];
                           [p,p,n,p];
                           [n,p,p,p]];

        [Ny,Nz]=size(TrueModel.theta);

        w_t = zeros(5,5,4);
        w_t(:,:,1) = [[0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, .33, 0, 0];
                      [0, 0, 0, 0, 0];                  
                      [0, 0, 0, 0, 0]];
        w_t(:,:,2) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .33, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0]];              
        w_t(:,:,3) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [1, 1, .33, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];  
        w_t(:,:,4) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .33, 1, 1];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];                
        w_t = w_t+0.01; Nx = 25;
        phi = zeros(Nx, Ny);
        for y = 1 : 4, phi(:,y) = normalise(reshape(w_t(:,:,y), [Nx, 1])); end
        TrueModel.Nd = 10;
        TrueModel.phi = phi;

        TrueModel.psi0 = ones(Nz,1)/Nz;
        %TrueModel.psi  = [[0.75, 0.25]; [0.25, 0.75]];
        psi           = [[2, 0, 0, 1];
                         [1, 2, 0, 0];
                         [0, 1, 2, 0];
                         [0, 0, 1, 2]];
        TrueModel.psi  = normalise(psi+0.02,2);
    end

    if(COND==444)
        %Allows straight, top left turn & bottom right turn.
        % Some random order.
        if(isfield(TrueModel,'eps'))
            eps = TrueModel.eps;
        else
            eps = 0.01;
        end
        p = 0.495;
        n = eps/2;
        % Only allow curves to follow straights.
        TrueModel.theta = [[p,p,n,n];
                           [p,n,n,p];
                           [n,p,p,n];
                           [n,n,p,p]];

        [Ny,Nz]=size(TrueModel.theta);

        w_t = zeros(5,5,4);
        w_t(:,:,1) = [[0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, .5, 0, 0];
                      [0, 0, 0, 0, 0];                  
                      [0, 0, 0, 0, 0]];
        w_t(:,:,2) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .5, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0]];              
        w_t(:,:,3) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [1, 1, .5, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];  
        w_t(:,:,4) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .5, 1, 1];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];                
        Nx = 25;                  
        TrueModel.X_Z = reshape(w_t, [Nx, 4])*(TrueModel.theta-0.01);
        w_t = w_t+eps/2;
        phi = zeros(Nx, Ny);
        for y = 1 : 4, phi(:,y) = normalise(reshape(w_t(:,:,y), [Nx, 1])); end
        TrueModel.Nd = 10;
        TrueModel.phi = phi;

        
        TrueModel.psi0 = ones(Nz,1)/Nz;
        %TrueModel.psi  = [[0.75, 0.25]; [0.25, 0.75]];
        psi           = [[2, 0, 0, 1];
                         [1, 2, 0, 0];
                         [0, 1, 2, 0];
                         [0, 0, 1, 2]];
        TrueModel.psi  = normalise(psi+eps/2,2);
    end    
    if(COND==4)
        % Only allow curves to follow straights.
        TrueModel.theta = [[0.49,0.49,0.01,0.01];
                           [0.49,0.01,0.01,0.49];
                           [0.01,0.49,0.49,0.01];
                           [0.01,0.01,0.49,0.49]];

        [Ny,Nz]=size(TrueModel.theta);

        w_t = zeros(5,5,4);
        w_t(:,:,1) = [[0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, .5, 0, 0];
                      [0, 0, 0, 0, 0];                  
                      [0, 0, 0, 0, 0]];
        w_t(:,:,2) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .5, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0]];              
        w_t(:,:,3) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [1, 1, .5, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];  
        w_t(:,:,4) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .5, 1, 1];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];                
        Nx = 25;                  
        TrueModel.X_Z = reshape(w_t, [Nx, 4])*(TrueModel.theta-0.01);
        w_t = w_t+0.02; 
        phi = zeros(Nx, Ny);
        for y = 1 : 4, phi(:,y) = normalise(reshape(w_t(:,:,y), [Nx, 1])); end
        TrueModel.Nd = 10;
        TrueModel.phi = phi;

        
        TrueModel.psi0 = ones(Nz,1)/Nz;
        %TrueModel.psi  = [[0.75, 0.25]; [0.25, 0.75]];
        psi           = [[2, 0, 0, 1];
                         [1, 2, 0, 0];
                         [0, 1, 2, 0];
                         [0, 0, 1, 2]];
        TrueModel.psi  = normalise(psi+0.02,2);
    end

    if(COND==7)
        % Only allow curves to follow straights.
        TrueModel.theta = [[0.49,0.49,0.01,0.01];
                           [0.49,0.01,0.01,0.49];
                           [0.01,0.49,0.49,0.01];
                           [0.01,0.01,0.49,0.49]];

        [Ny,Nz]=size(TrueModel.theta);

        w_t = zeros(7,7,4);
        w_t(:,:,1) = [[0, 0, 0, 1, 0, 0, 0];
                      [0, 0, 0, 1, 0, 0, 0];
                      [0, 0, 0, 1, 0, 0, 0];
                      [0, 0, 0, .5,0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];                  
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0]];
        w_t(:,:,2) = [[0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, .5,0, 0, 0];
                      [0, 0, 0, 1, 0, 0, 0];
                      [0, 0, 0, 1, 0, 0, 0];
                      [0, 0, 0, 1, 0, 0, 0]];     
        w_t(:,:,3) = [[0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];
                      [1, 1, 1, .5,0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0]];  
        w_t(:,:,4) = [[0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, .5,1, 1, 1];
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0, 0, 0]];             
        w_t = w_t+0.01; Nx = 49;
        phi = zeros(Nx, Ny);
        for y = 1 : 4, phi(:,y) = normalise(reshape(w_t(:,:,y), [Nx, 1])); end
        TrueModel.Nd = 10;
        TrueModel.phi = phi;

        TrueModel.psi0 = ones(Nz,1)/Nz;
        %TrueModel.psi  = [[0.75, 0.25]; [0.25, 0.75]];
        psi           = [[2, 0, 0, 1];
                         [1, 2, 0, 0];
                         [0, 1, 2, 0];
                         [0, 0, 1, 2]];
        TrueModel.psi  = normalise(psi+0.02,2);
    end
    
    if(COND==3)
        TrueModel.psi0  = ones(2,1)/2;
        TrueModel.theta = [[0.49,0.01];
                           [0.49,0.01];
                           [0.01,0.49];
                           [0.01,0.49]]; Ny=4;
        w_t = zeros(5,5,4);
        w_t(:,:,1) = [[0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, .25, 0, 0];
                      [0, 0, 0, 0, 0];                  
                      [0, 0, 0, 0, 0]];
        w_t(:,:,2) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .25, 0, 0];
                      [0, 0, 1, 0, 0];
                      [0, 0, 1, 0, 0]];              
        w_t(:,:,3) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [1, 1, .25, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];  
        w_t(:,:,4) = [[0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0];
                      [0, 0, .25, 1, 1];
                      [0, 0, 0, 0, 0];
                      [0, 0, 0, 0, 0]];                
        w_t = w_t+0.05; Nx = 25;
        phi = zeros(Nx, Ny);
        for y = 1 : 4, phi(:,y) = normalise(reshape(w_t(:,:,y), [Nx, 1])); end
        TrueModel.Nd = 10;
        TrueModel.phi = phi;

        TrueModel.psi = [[0.75, 0.25]; [0.25, 0.75]];
    end
    if(COND>0 && COND<=2) %?% Also >0?
        TrueModel.Nd  = 15;
        TrueModel.psi0 = ones(3,1)/3;
        TrueModel.psi = [[0.70, 0.05, 0.25];
                         [0.25, 0.70, 0.05];
                         [0.05, 0.25, 0.70]];
        if(COND==1)
            %Three topics.
            TrueModel.theta = [[0.45, 0.10, 0.45];
                               [0.45, 0.45, 0.10];
                               [0.10, 0.45, 0.45]];
            TrueModel.phi   = [normalise([0.95, 0.05, 0.05, 0.95, 0.05, 0.05, 0.25]);
                               normalise([0.05, 0.95, 0.05, 0.05, 0.95, 0.05, 0.25]);
                               normalise([0.05, 0.05, 0.95, 0.05, 0.05, 0.95, 0.25])]';
           Ny = size(TrueModel.theta,1);
        end
        if(COND==2) % I guess speciifcally for LDA.
            theta = [[0.45, 0.45, 0.1];    %Topic dist doc 1
                     [0.1, 0.45, 0.45];    %Topic dist doc 2
                     [0.3, 0.3, 0.4];
                     [0.05, 0.05, 0.9];    %Topic dist doc 4
                     [0.9, 0.05, 0.05];    %Topic dist doc 5         
                     [0.05, 0.9, 0.05]]';   %Topic dist doc 6  
            phi = [normalise([0.9, 0.1, 0.1, 0.9, 0.1, 0.1, 0.5]);
                   normalise([0.1, 0.9, 0.1, 0.1, 0.9, 0.1, 0.5]);
                   normalise([0.1, 0.1, 0.9, 0.1, 0.1, 0.9, 0.5])]';     
            TrueModel.theta = theta;
            TrueModel.phi = phi;
            TrueModel.Nd = 30; %30 Words per document.
            TrueModel.T  = 6;
            Ny = size(theta,1);
        end
    end
%end


TrueModel.chi = zeros(Ny, TrueModel.T);


function phi=intersectionPhi
w_t = zeros(5,5,4);
w_t(:,:,1) = [[0, 0, 1, 0, 0];
              [0, 0, 1, 0, 0];
              [0, 0, .25, 0, 0];
              [0, 0, 0, 0, 0];                  
              [0, 0, 0, 0, 0]];
w_t(:,:,2) = [[0, 0, 0, 0, 0];
              [0, 0, 0, 0, 0];
              [0, 0, .25, 0, 0];
              [0, 0, 1, 0, 0];
              [0, 0, 1, 0, 0]];              
w_t(:,:,3) = [[0, 0, 0, 0, 0];
              [0, 0, 0, 0, 0];
              [1, 1, .25, 0, 0];
              [0, 0, 0, 0, 0];
              [0, 0, 0, 0, 0]];  
w_t(:,:,4) = [[0, 0, 0, 0, 0];
              [0, 0, 0, 0, 0];
              [0, 0, .25, 1, 1];
              [0, 0, 0, 0, 0];
              [0, 0, 0, 0, 0]];                
w_t = w_t+0.02; Nx = 25; Ny=4;

phi = zeros(Nx, Ny);
for y = 1 : 4, phi(:,y) = normalise(reshape(w_t(:,:,y), [Nx, 1])); end
