function [Rstat, mean_new, disp_new] = util_gelman_Rrec(s, Rrec, LOG)
%% function [Rstat, mean_new, disp_new] = util_gelman_Rrec(s, Rrec, LOG)
% Gelman's method for measuring sampling convergence

[N,M]=size(LOG);
if(s==1)
    mean_old = zeros(size(Rrec.mean));
    disp_old = zeros(size(Rrec.disp));
else
    mean_old = Rrec.mean;
    disp_old = Rrec.disp;    
end

mean_new = zeros(size(mean_old));
disp_new = zeros(size(disp_old));
W = zeros(N,1);
B = zeros(N,1);
Rstat = zeros(N,1);
for j = 1 : M
    delta = LOG(:,j)-mean_old(:,j);
    mean_new(:,j) = mean_old(:,j) + delta/s;
    disp_new(:,j) = disp_old(:,j) + delta.*(LOG(:,j)-mean_new(:,j));    
end
% if(s>1) %Initial condition...?
%     var_new = disp_new/(s);
% end
if(s>1)
    W = sum(disp_new,2);
    W=W/((s-1)*M);
    for t = 1 : N
        mean_seq = mean_new(t,:);
        overall_mean = mean(mean_seq);
        B(t)=(s/(M-1))*sum((mean_seq-overall_mean).^2);
    end
    Rstat = sqrt(((s-1)*W/s+B/s)./W);
end