function BM = util_recalculateStats_LDA(BM,TM)
%% Recalculate sufficient statistics from raw samples.
% LDA model.

%% Initialize data structure.
%[Nx, Ny]=size(TM.phi);
[Nx, Ny]=size(BM.n_xy);
T = TM.T;

BM.n_ym = zeros(Ny,T);  %Document-Topic count.
BM.n_xy = zeros(Nx,Ny); %Topic-Vocab count.
%BM.n_m  = zeros(T,1);
%BM.n_z  = zeros(Ny,1);  

for t = 1 : T
    tmp =  histc(BM.sampY(:,t),1:Ny+1);  %Topic-document count matrix.
    BM.n_ym(:,t) = tmp(1:Ny);
    %BM.n_ym(:,t) = hist(BM.sampY(:,t),0:Ny);  %Topic-document count matrix.
    for i = 1 : TM.Nd
        x = BM.X(i,t); y = BM.sampY(i,t);
        BM.n_xy(x,y) = BM.n_xy(x,y)+1;
    end
end
BM.n_sym = sum(BM.n_ym, 1);   % Number of topic/word instances per document
BM.n_sxy = sum(BM.n_xy, 1);   % Number of instances of each topic.