function [Y_s,pD_M,R_s] = util_sample_LDA(Nx,Ny,Nw,Nd,Ns,TM,X)
%% function [Y_s,pD_M,R_s] = util_sample_LDA(Nx,Ny,Nw,Nd,Ns,TM,X)
% Sapmle from a LDA models prior. For empirical likelihood model seleciton.

if(nargin>5)
    %Assume we're given data and want to compute it's likelihood (prior
    %sampling).
    USE_DATA=true;
else
    %Assume just want to sample up to latents y.
    USE_DATA=false;
end
BM.Nd = Nd;
BM.Nx = Nx;
BM.Ny = Ny;
BM.gamma = 1;
BM.beta  = 1;
BM.n_xy = zeros(Nx, Ny);
BM.n_yy = zeros(Ny, Ny); 
BM.n_sxy = zeros(1,Ny);
BM.n_syy = zeros(1,Ny);
BM.T = Nd;
BM.gamma = 1;
BM.beta  = 1;
BM.n_yz = [];
BM.n_zz = [];
BM.n_szz = [];
BM.n_syz = [];
BM.n_z = [];
BM.n_sz = [];
Y_s = zeros(Nw, Nd, Ns);

R_s.lpX_Y = zeros(1,Ns);
R_s.lpY   = zeros(1,Ns);
R_s.lpXY  = zeros(1,Ns);
R_s.n_xy  = zeros(Nx,Ny,Ns);
pD_M = 0;
phi   = zeros(Nx,Ny);
theta = zeros(Ny,Nd);
for s = 1 : Ns
    BM.X=X;    
    for y = 1 : Ny
        %Sample word|topic dist.
        phi(:,y) = dirichlet_sample(ones(Nx,1),1);
    end
    for d = 1 : Nd
        %Sample topic|document dist.
        theta(:,d) = dirichlet_sample(ones(Ny,1),1);
        Y_s(:,d,s) = sample(theta(:,d),Nw);
        BM.sampY(:,d) = Y_s(:,d,s);
%         for w = 1 : Nw
%             %Sample topic.
%             Y_s(w,d,s) = sum(cumsum(theta(:, d)) < rand) + 1;
%             BM.sampY(w,d) = Y_s(w,d,s);
%         end
    end
    if(USE_DATA)
        BM = util_recalculateStats_LDA(BM,TM);
        [R_s.lpX_Y(1,s)] = util_llh_MCLDA(BM, TM);
        R_s.n_xy(:,:,s) = BM.n_xy;
    end
end
if(USE_DATA)
    pD_M = mean(R_s.lpX_Y(:));
end
